#include <stdio.h>

int main( int argc, char *argv[] )
{
    if( argc != 3  ) { printf( "use: cssMinifier.exe input.css output.css\n" ); return -1; }

    FILE *fi = fopen( argv[1], "rb" ); if( !fi ) { printf( "can't read input\n" ); return -2; }
    FILE *fo = fopen( argv[2], "wb" ); if( !fo ) { printf( "can't write output\n" ); return -3; }

    int iLen = 0;
    int oLen = 0;
    int numChars;
    bool noSpaces = false;
    bool noComments = false;
    char str[2048];
    while( (numChars = fread( str, 1, sizeof(str), fi )) != 0 )
    {
        int o = 0;
        for( int i=0; i<numChars; i++ )
        {
            // remove comments
            if( noComments && str[i]=='*' && str[i+1]=='/' ) { noComments = false; i++; continue; }
            if( noComments ) continue; 
            if( str[i]=='/' && str[i+1]=='*' ) {noSpaces=false; noComments = true; i++; continue; }

            // remove spaces
            if( str[i]!=' ' && str[i]!='\t' ) noSpaces = false;
            if( str[i]=='\r' || str[i]=='\n' || (noSpaces && (str[i]==' ' || str[i]=='\t') ) ) { noSpaces = true; continue; }
            if( str[i]=='{' ) { while( (o>1) && (str[o-1]==' ' || str[o-1]=='\t') ) o--; }
            if( str[i]=='>' ) { while( (o>1) && (str[o-1]==' ' || str[o-1]=='\t') ) o--; }
            if( str[i]==':' || str[i]==';' || str[i]==',' || str[i]=='>') noSpaces = true;

            // copy
            str[o++] = str[i];
        }
        fwrite( str, 1, o, fo );
        iLen += numChars;
        oLen += o;
    }

    fclose(fi);
    fclose(fo);

    printf( "From %d chars to %d chars", iLen, oLen );

    return 0;
}